

KEY     ;( -- char , input a key from the keyboard )
        push    eax
        xor     eax, eax
        int     0x16
        xor     ah,ah
        upsh    eax
        pop     eax
        ret
end KEY


ACCEPT  ;( c-addr +n1 -- +n2 , Input at most +n1 chars from kbd into c-addr )
        push    eax
        push    ebx
        push    ecx
        push    edi

        upop    ecx             ;Max chars
        upop    ebx             ;Buffer address
        xor     edi, edi        ;BX+DI = current position
.loop
        xor     ah, ah
        int     0x16            ;Input a key

        cmp     al, 13          ;Return = done
        je      .end
        cmp     al, 8           ;Backspace
        je      .backspace

        cmp     edi, ecx        ;Ignore any new input if at end of buffer
        je      .loop

        mov     [ebx+edi], al   ;Write char to memory buffer
        call    .printchar
        inc     edi
        jmp     .loop           ;Get another char

.end
        mov     [ebx+edi], byte 0       ;Null terminator
        upsh    edi

        pop     edi
        pop     ecx
        pop     ebx
        pop     eax
        ret

.backspace
        cmp     edi, 0
        je      .loop
        dec     edi
        call    .printchar
        mov     al, 0
        call    .printchar
        mov     al, 8
        call    .printchar
        jmp     .loop

.printchar
        push    ebx             ;Print char to screen
        mov     ah, 0x0E
        mov     bx, 0
        int     0x10
        pop     ebx
        ret
end ACCEPT


